# PFotos 1.2 Copyright(C) 2017-2019 Cora Kohlmeier, Frank Hamberg
# Code kombiniert aus diversen Forenbeiträgen zum Thema "tcl/tk image resizing"
proc scaleImage {im factor} {
# Integerwerte für zoom und subsample aus $factor erzeugen
if {$factor < 1} {
   set factors [Double2Fraction $factor 64 0.01]
} else {
# bei normalen Thumbnails, die nur etwas kleiner als das Fenster sind, wird nicht skaliert. Sieht pixelig aus.
   return
}	
set fzoom [lindex $factors 0]
set fshrink [lindex $factors 1]

set t [image create photo]
$t copy $im -zoom $fzoom $fzoom -compositingrule set
$im blank
$im copy $t -shrink -subsample $fshrink $fshrink
image delete $t
}

proc Double2Fraction { dbl {maxden 64} {eps 0.01}} {
# für Geschwindigkeit und minimale Speichernutzung wird $den auf 64 begrenzt
# soll mehr als ein Thumbnail erzeugt werden, $den bis 1024 und eps auf 0.000001 setzen
    for {set den 1} {$den<$maxden} {incr den} {
        set num [expr {round($dbl*$den)}]
        if {abs(double($num)/$den - $dbl) < $eps} break
    }
    list $num $den
}
